// -*- mode:c++ -*-
//
// Module Location.cc
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 8/31	rmg	File creation
//
// $Id: Location.cc,v 1.3 2002/09/01 14:16:59 raoul Exp $
//

#include "Location.hh"

#include <iostream>
#include <algorithm>

/////////////////////////////////////////////////////////////////////////////
// Input routine
/////////////////////////////////////////////////////////////////////////////

std::istream &operator>> (std::istream &strm, Location &loc)
{
  Location temp;

  char c;

  strm >> c;  // Skips whitespace (unless skipws cleared)

  if (!strm)
    {
      // Couldn't get the first char. Oh no!
    }

  else if ((c == 'X') || (c == 'x'))
    {
      // Skip the X

      strm >> temp.first;
      strm >> c;  // Skip the Y
      strm >> temp.second;
    }

  else if ((c >= '0') && (c <= '9'))
    {
      strm.unget(); // Put the non-whitespace char back
      strm >> temp.first;
      strm >> temp.second;
    }

  else
    {
      // We couldn't read a location from the stream

      strm.unget(); // Put the non-whitespace char back
      strm.setstate (std::ios::failbit);
    }

  if (strm.good())
    {
      --temp.first; // Compensate for one-based coordinates
      --temp.second; // Compensate for one-based coordinates

      std::swap (temp, loc);
    }

  return strm;
}

/////////////////////////////////////////////////////////////////////////////
// Output routine
/////////////////////////////////////////////////////////////////////////////

std::ostream &operator<< (std::ostream &strm, Location const &loc)
{
  strm << "(" << loc.first << ", " << loc.second << ")";
  return strm;
}
