// -*- mode:c++ -*-
//
// Header file LogStream.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 8/31	rmg	File creation
//
// $Id: LogStream.hh,v 1.3 2002/09/02 10:55:31 raoul Exp $
//

#ifndef LogStream_rmg_20020831_included
#define LogStream_rmg_20020831_included

#include <iostream>

struct LogStream
{
  LogStream (std::ostream *strmPtr) : mStrmPtr (strmPtr) { }

  ostream *mStrmPtr;
};

template<typename T>
LogStream const &operator<< (LogStream const &strm, T const &t)
{
  if (strm.mStrmPtr)
    {
      (*strm.mStrmPtr) << t;
    }

  return strm;
}

template<typename T>
LogStream const &operator<< (LogStream const &strm, T &t)
{
  if (strm.mStrmPtr)
    {
      (*strm.mStrmPtr) << t;
    }

  return strm;
}

LogStream const &logStream ();
void logStream (std::ostream *);

LogStream const &debugStream ();
void debugStream (std::ostream *);

LogStream const &commStream (); // For server communication logging
void commStream (std::ostream *);

#endif // LogStream_rmg_20020831_included
