// -*- mode:c++ -*-
//
// Header file PackageGroup.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 2	rmg	File creation
//
// $Id: PackageGroup.hh,v 1.1 2002/09/02 16:34:18 raoul Exp $
//

#ifndef PackageGroup_rmg_20020902_included
#define PackageGroup_rmg_20020902_included

#include "PackageInfo.hh"
#include "AddressInfo.hh"
#include <map>
#include <set>
#include <vector>

typedef std::set<PackageInfo> AddressSet;

class PackageGroup
{
public:
  PackageGroup ();

  void insert (PackageInfo const &p);
  PackageInfo remove (int id);

  int totalWeight () const { return mTotalWeight; }
  int size () const { return mCount; }

  void reset ();

  AddressSet const &byAddress () const { return mByAddress; }

  AddressSet::const_iterator beginAt (std::pair<int, int> const &loc) const;

  AddressSet::const_iterator endAt (std::pair<int, int> const &loc) const;

private:
  int mTotalWeight;
  int mCount;
  std::map<int, PackageInfo> mById;
  AddressSet mByAddress;
};

#endif // PackageGroup_rmg_20020902_included
