// -*- mode:c++ -*-
//
// Module PackageInfo.cc
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 8/31	rmg	File creation
//
// $Id: PackageInfo.cc,v 1.3 2002/09/02 13:54:25 raoul Exp $
//

#include "PackageInfo.hh"

#include <iostream>

/////////////////////////////////////////////////////////////////////////////
// Extractor
/////////////////////////////////////////////////////////////////////////////

std::istream &operator>> (std::istream &strm, PackageInfo &pInfo)
{
  strm
    >> pInfo.mId
    >> pInfo.mDestX
    >> pInfo.mDestY
    >> pInfo.mWeight;

  --pInfo.mDestX; // Compensate for one-based coordinates
  --pInfo.mDestY; // Compensate for one-based coordinates

  return strm;
}

/////////////////////////////////////////////////////////////////////////////
// Inserter
/////////////////////////////////////////////////////////////////////////////

std::ostream &operator<< (std::ostream &strm, PackageInfo const &pInfo)
{
  strm
    << pInfo.mId
    << " destination ("
    << pInfo.mDestX
    << ", "
    << pInfo.mDestY
    << ") weight " << pInfo.mWeight;

  return strm;
}

