// -*- mode:c++ -*-
//
// Header file PackageInfo.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 8/31	rmg	File creation
//
// $Id: PackageInfo.hh,v 1.2 2002/09/02 16:35:06 raoul Exp $
//

#ifndef PackageInfo_rmg_20020831_included
#define PackageInfo_rmg_20020831_included

#include <iosfwd>

struct PackageInfo
{
  PackageInfo () { }
  PackageInfo (int id) : mId (id), mDestX (-1), mDestY (-1), mWeight (0) { }

  int mId;
  int mDestX;
  int mDestY;
  int mWeight;
};

std::istream &operator>> (std::istream &, PackageInfo &);
std::ostream &operator<< (std::ostream &, PackageInfo const &);

inline bool operator< (PackageInfo const &l, PackageInfo const &r)
{
  // Sort by address, weight and ID
  if (l.mDestX < r.mDestX)
    {
      return true;
    }

  else if (l.mDestX > r.mDestX)
    {
      return false;
    }

  else if (l.mDestY < r.mDestY)
    {
      return true;
    }

  else if (l.mDestY > r.mDestY)
    {
      return false;
    }

  else if (l.mWeight < r.mWeight)
    {
      return true;
    }

  else if (l.mWeight > r.mWeight)
    {
      return false;
    }

  else if (l.mId < r.mId)
    {
      return true;
    }

  else
    {
      return false;
    }
}

#endif // PackageInfo_rmg_20020831_included
