// -*- mode:c++ -*-
//
// Module Path.cc
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 2	rmg	File creation
//
// $Id: Path.cc,v 1.1 2002/09/02 08:49:41 raoul Exp $
//

#include "Path.hh"

int Path::forwardPath (int source) const
{
  int prev = -1;

  for (Container::const_iterator iter = mPath.begin()
	 ; iter != mPath.end()
	 ; ++iter)
    {
      if (prev == source)
	{
	  return *iter;
	}

      prev = *iter;
    }

  return -1;
}


int Path::reversePath (int source) const
{
  int prev = -1;

  for (Container::const_reverse_iterator iter = mPath.rbegin()
	 ; iter != mPath.rend()
	 ; ++iter)
    {
      if (prev == source)
	{
	  return *iter;
	}

      prev = *iter;
    }

  return -1;
}

int Path::next (int from, int to) const
{
  if (mPath.back() == to)
    {
      return forwardPath (from);
    }

  else if (mPath.front() == to)
    {
      return reversePath (from);
    }

  else if (mPath.back() == from)
    {
      return reversePath (to);
    }

  else if (mPath.front() == from)
    {
      return forwardPath (to);
    }

  else
    {
      return -1;
    }
}
