// -*- mode:c++ -*-
//
// Header file Path.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 2	rmg	File creation
//
// $Id: Path.hh,v 1.1 2002/09/02 08:49:36 raoul Exp $
//

#ifndef Path_rmg_20020902_included
#define Path_rmg_20020902_included

#include <vector>

class Path
{
  friend class SpanningTree;

public:
  int next (int from, int to) const;

  int totalLength () const { return mPath.size(); }

private:
  void add (int n)
  {
    mPath.push_back (n);
  }

  int reversePath (int to) const;
  int forwardPath (int from) const;

private:
  typedef std::vector<int> Container;

  Container mPath;
};

#endif // Path_rmg_20020902_included
