// -*- mode:c++ -*-
//
// Header file Robot.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 2	rmg	File creation
//
// $Id: Robot.hh,v 1.3 2002/09/02 16:34:40 raoul Exp $
//

#ifndef Robot_rmg_20020902_included
#define Robot_rmg_20020902_included

#include "PackageInfo.hh"
#include "PackageGroup.hh"
#include "RobotInfo.hh"

class World;

class Robot
{
public:
  Robot (World &world, int id = -1);
  Robot (World &world, RobotInfo const &);

  virtual ~Robot ();

  int id () const { return mId; }

  virtual void setLocation (int);
  virtual int location ();

  virtual void pickPackage (PackageInfo const &);
  virtual PackageInfo dropPackage (int id);

  virtual int capacity () const;
  virtual int money () const;

  World *worldPtr() const { return mWorldPtr; }

  void score (int i) { mScore += i; }
  int score () const { return mScore; }

  PackageGroup &packages() { return mPackages; } // Uuhhh

private:
  World *mWorldPtr;
  int mLocation;
  int mId;
  int mCapacity;
  int mMoney;
  int mScore;

  PackageGroup mPackages;
};

#endif // Robot_rmg_20020902_included
