// -*- mode:c++ -*-
//
// Header file SmartRobot.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 2	rmg	File creation
//
// $Id: SmartRobot.hh,v 1.4 2002/09/02 18:23:13 raoul Exp $
//

#ifndef SmartRobot_rmg_20020902_included
#define SmartRobot_rmg_20020902_included

#include "Robot.hh"
#include <iosfwd>
#include <string>

class World;

class SmartRobot : public Robot
{
public:
  SmartRobot (World &w, RobotInfo const &info);

  void setGoal (int g);

  void makeMove (std::ostream &);

private:
  bool moveToGoal ();
  bool deliveriesHere ();
  bool pickupsHere ();
  void randomMove ();

  void calcNextDelivery ();
  void calcNextPickup ();

  void sendCommand (std::ostream &strm, char const *str);
  void sendCommand (std::ostream &strm, std::string const &str);

  virtual void pickPackage (PackageInfo const &);
  virtual PackageInfo dropPackage (int id);

private:
  int mGoal;
  std::string mCommand;
  int mPackageChange;
  int mBaseEmergency;
};

#endif // SmartRobot_rmg_20020902_included
