// -*- mode:c++ -*-
//
// Module SpanningTree.cc
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 1	rmg	File creation
//
// $Id: SpanningTree.cc,v 1.3 2002/09/02 12:02:22 raoul Exp $
//

#include "SpanningTree.hh"
#include <algorithm>

////////////////////////////////////////////////////////////////////////////
// Constructor
////////////////////////////////////////////////////////////////////////////

SpanningTree::SpanningTree (int nVertices, int root)
  : mPredecessor (nVertices)
{
  reset (root);
}

////////////////////////////////////////////////////////////////////////////
// Reset
////////////////////////////////////////////////////////////////////////////

void SpanningTree::reset (int root)
{
  mRoot = root;
  std::fill (mPredecessor.begin(), mPredecessor.end(), -1);
}

////////////////////////////////////////////////////////////////////////////
// Path extractor
////////////////////////////////////////////////////////////////////////////

Path SpanningTree::pathFromRoot (int n) const
{
  Path result;

  while ((n != mRoot) && (n != -1))
    {
      result.add (n);

      n = mPredecessor[n];
    }

  result.add (mRoot);

  return result;
}
