// -*- mode:c++ -*-
//
// Header file SquareInfo.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 2	rmg	File creation
//
// $Id: SquareInfo.hh,v 1.1 2002/09/02 16:35:37 raoul Exp $
//

#ifndef SquareInfo_rmg_20020902_included
#define SquareInfo_rmg_20020902_included

#include "PackageInfo.hh"
#include "PackageGroup.hh"
#include <map>

#include <boost/smart_ptr.hpp>
#include "SpanningTree.hh"

class SquareInfo
{
public:
  PackageGroup const &packages() const { return mPackages; }
  PackageGroup &packages() { return mPackages; }

  boost::shared_ptr<SpanningTree> const &tree () const
  {
    return mSpanningTree;
  }

  void tree (boost::shared_ptr<SpanningTree> const &t)
  {
    mSpanningTree = t;
  }

private:
  PackageGroup mPackages;
  boost::shared_ptr<SpanningTree> mSpanningTree;
};

#endif // SquareInfo_rmg_20020902_included
