// -*- mode:c++ -*-
//
// Header file TinyEdgeDestIterator.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 9/ 1	rmg	File creation
//
// $Id: TinyEdgeDestIterator.hh,v 1.1 2002/09/01 16:47:13 raoul Exp $
//

#ifndef TinyEdgeDestIterator_rmg_20020901_included
#define TinyEdgeDestIterator_rmg_20020901_included

#include "TinyEdgeIterator.hh"

class TinyEdgeDestIterator
{
public:
  TinyEdgeDestIterator (TinyEdgeSet const *setPtr
			, TinyEdgeSet const *limitPtr
			, int n
			, int width)
    : mIter (setPtr, limitPtr, n, width)
  {
  }


  TinyEdgeDestIterator () : mIter () { }

  int operator* ()
  {
    return (*mIter).second;
  }

  TinyEdgeDestIterator &operator++ ()
  {
    ++mIter;
    return *this;
  }

  TinyEdgeDestIterator operator++ (int)
  {
    TinyEdgeDestIterator temp = *this;
    ++(*this);
    return temp;
  }

  bool operator== (TinyEdgeDestIterator const &other)
  {
    return mIter == other.mIter;
  }

  bool operator!= (TinyEdgeDestIterator const &other)
  {
    return !((*this) == other);
  }

private:
  TinyEdgeIterator mIter;
};

#endif // TinyEdgeDestIterator_rmg_20020901_included
