// -*- mode:c++ -*-
//
// Header file socket_port.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 8/30	rmg	File creation
//
// $Id: socket_port.hh,v 1.5 2002/08/31 22:01:59 Raoul Exp $
//

#ifndef socket_port_rmg_20020830_included
#define socket_port_rmg_20020830_included

#if (defined __WIN32__) || (defined _MSC_VER)

// Windows

#include <winsock2.h>

// Oh, the hackery of it all. Fix boost::fdstream for sockets
#ifdef _MSC_VER
# include <io.h>
#else
# include <unistd.h>
#endif
#define read(P1, P2, P3) recv ((P1), (P2), (P3), 0)
#define write(P1, P2, P3) send ((P1), (P2), (P3), 0)

typedef int accept_len_type;

#define LASTERROR WSAGetLastError()

#define OS_STARTUP \
{ \
  WSADATA crap; \
\
  if (FAILED (WSAStartup (0x0101, &crap))) \
    { \
      fprintf (stderr, "WSAStartup: %d\n", LASTERROR); \
\
      return 1;\
    } \
}

#define OS_SHUTDOWN \
  if (FAILED (WSACleanup ())) \
    { \
      fprintf (stderr, "WSACleanup: %d\n", LASTERROR); \
      return 1; \
    }

#define sleep(n) _sleep((n)*1000)
#define CLOSESOCKET closesocket

#else

// Unix

typedef unsigned accept_len_type;

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <errno.h>
#define LASTERROR strerror (errno)

#define OS_STARTUP
#define OS_SHUTDOWN

#define CLOSESOCKET close

typedef int int_type;

struct traits_type
{
  static int to_int_type (char c) { return static_cast<int_type> (c); }
};

#endif

#endif // socket_port_rmg_20020830_included
