// -*- mode:c++ -*-
//
// Module testsb.cc
//
// Copyright (c) 2002 Raoul M. Gough
//
// History
// =======
// 2002/ 8/31	rmg	File creation
//
// $Id: testsb.cc,v 1.4 2002/09/01 20:34:29 raoul Exp $
//

#include "StaticBoard.hh"
#include <iostream>
#include <stdexcept>

void dumpEdges (std::ostream &strm, StaticBoard const &b, int x, int y)
{
  TinyEdgeSet edgeSet = edges (b, x, y);

  if (edgeSet.hasEdge (TinyEdgeSet::north))
    {
      strm << "n";
    }

  if (edgeSet.hasEdge (TinyEdgeSet::south))
    {
      strm << "s";
    }

  if (edgeSet.hasEdge (TinyEdgeSet::east))
    {
      strm << "e";
    }

  if (edgeSet.hasEdge (TinyEdgeSet::west))
    {
      strm << "w";
    }
}

int main ()
{
  StaticBoard b;

  try
    {
      std::cin >> b;

      std::cout << b;

      dumpEdges (std::cout, b, 0, 0);
      std::cout << "\n";

      dumpEdges (std::cout, b, b.width() - 1, 0);
      std::cout << "\n";

      dumpEdges (std::cout, b, 0, b.height () - 1);
      std::cout << "\n";

      dumpEdges (std::cout, b, b.width() - 1, b.height() - 1);
      std::cout << "\n";
    }

  catch (std::runtime_error const &err)
    {
      std::cerr << err.what() << std::endl;
    }
}
