// -*- mode:c++ -*-
//
// Header file utils.hh
//
// Copyright (c) 2002 Raoul M. Gough
//
// Utilities for the broken 2.x GNU C++ library
//
// History
// =======
// 2002/ 8/31	rmg	File creation
//
// $Id: utils.hh,v 1.2 2002/08/31 12:40:53 raoul Exp $
//

#ifndef utils_rmg_20020831_included
#define utils_rmg_20020831_included

#ifdef __GNUC__
#if !__GNUC_PREREQ(3, 0)

#include <string>
#include <iostream>

inline void getline (std::istream &strm
		     , std::string &dest
		     , char delim = '\n')
{
  char buff[1024];
  int nRead = 0;

  dest.erase ();

  do {
    strm.get (buff, sizeof(buff), delim);

    nRead = strm.gcount();

    if (nRead != 0)
      {
	dest += buff;
      }

  } while (strm && (nRead != 0));

  if (strm)
    {
      strm.ignore (1); // Skip the delimiter
    }
}

#endif
#endif

#endif // utils_rmg_20020831_included
